﻿
//	Amazon Search Dashboard Widget
//	Copyright (c) 2005 Edward Anastas
//	http://www.wishcentral.com/

var categoryIndex = 0;
var local = getLocalizedString('com'); //'com';
var stretcher;
var stretcherPositionOpen;


var localCategories_de = [
	{category:'Alle Produkte', value:'blended'},
	{category:'B\xFCcher', value:'books-de'},
	{category:'English Books', value:'books-de-intl-us'},
	{category:'Zeitschriften', value:'dvd-de'},
	{category:'Musik', value:'music-de'},
	{category:'DVD', value:'dvd-de'},
	{category:'Video VHS', value:'vhs-de'},
	{category:'Elektronik & Foto', value:'ce-de-all'}, //cd-de
	{category:'Computer & Zubeh\xF6r', value:'pc-de'}, // ö
	{category:'Kamera & Foto', value:'photo-de'},
	{category:'Haus & Garten', value:'kitchen-de-all'},
	{category:'K\xFCche & Haushalt', value:'kitchen-de'},
	{category:'Heimwerken', value:'tools-de'},	
	{category:'Garten & Freizeit', value:'garden-de'},
	{category:'K\xF6rperpflege & Bad', value:'hpc-de'},
	{category:'Software', value:'software-de'},
	{category:'PC & Videospiele', value:'video-games-de'},
	{category:'Spielware', value:'toys-de'}
];


var localCategories_com = [
	{category:'All Products', value:'blended'},
	{category:'Books', value:'books'},
	{category:'Popular Music', value:'music'},
	{category:'Music Downloads', value:'music-dd'},
	{category:'Classical Music', value:'classical'},
	{category:'DVD', value:'dvd'},
	{category:'VHS', value:'vhs'},
	{category:'Apparel & Accessories', value:'apparel-index'},
	{category:'Yellow Pages', value:'local-index'},
	{category:'Restaurants', value:'restaurants'},
	{category:'Movie Showtimes', value:'theatrical'},
	{category:'Toys & Games', value:'toys'},
	{category:'Baby', value:'baby'},
	{category:'Computers', value:'pc-hardware'},
	{category:'Video Games', value:'videogames'},
	{category:'Electronics', value:'electronics'},
	{category:'Camera & Photo', value:'photo'},
	{category:'Software', value:'software'},
	{category:'Tools & Hardware', value:'tools'},
	{category:'Office Products', value:'office-products'},
	{category:'Magazines', value:'magazines'},
	{category:'Sports & Outdoors', value:'sporting-index'},
	{category:'Outdoor Living', value:'garden'},
	{category:'Kitchen', value:'kitchen'},
	{category:'Jewelry & Watches', value:'jewelry-index'},
	{category:'Gourmet Food', value:'gourmet-index'},
	{category:'Beauty', value:'beauty-index'},
	{category:'Musical Instruments', value:'mi-index'},
	{category:'Health & Personal Care', value:'hpc-index'},
	{category:'Travel', value:'books&field-browse=27&store-name=travel'},
	{category:'Cell Phones & Service', value:'wireless-phones'},
	{category:'Outlet', value:'outlet'},
	{category:'Auctions', value:'auction-redirect'},
	{category:'zShops', value:'fixed-price-redirect'},
	{category:'Miscellaneous', value:'universal'},
	{category:'Everything Else', value:'misc'},
	{category:'Automotive', value:'automotive-index'}
];


var localCategories_uk = [
	{category:'All Products', value:'blended'},
	{category:'Books', value:'books-uk'},
	{category:'e-Books', value:'books-uk:ebooks'},
	{category:'Electronics & Photo', value:'electronics-uk'},
	{category:'Music', value:'music'},
	{category:'DVD', value:'dvd-uk'},
	{category:'Video VHS', value:'vhs-uk'},
	{category:'Software', value:'software-uk'},
	{category:'Music', value:'music'},
	{category:'Computer & Video Games', value:'video-games-uk'},
	{category:'Software & Games', value:'sw-vg-uk'},
	{category:'DIY & Tools', value:'tools-uk'},
	{category:'Garden & Outdoors', value:'garden-uk'},
	{category:'Kitchen & Home', value:'kitchen-uk'},
	{category:'Personal Care', value:'hpc-uk'},
	{category:'Toys', value:'toys-uk'},
	{category:'Auctions', value:'auction-uk-redirect'},
	{category:'zShops', value:'zshops-uk-redirect'}
];


var localCategories_fr = [
	{category:'Tous les produits', value:'blended'},
	{category:'Livres en Fran\xE7ais', value:'books-fr'},
	{category:'Livres', value:'books-fr-intl-us'},
	{category:'Pop, V.F., Jazz...', value:'music-fr'},
	{category:'Musique', value:'music-fr'},
	{category:'DVD', value:'dvd-fr'},
	{category:'Vid\xE9o VHS', value:'vhs-fr'},
	{category:'Logiciels', value:'software-fr'},
	//{category:'Logiciels et consommables', value:'sw-vg-fr'},
	{category:'Jeux vid\xE9os', value:'video-games-fr'} //Jeux vid&eacute;o
];


var localCategories_ca = [
	{category:'All Products', value:'blended'},
	{category:'Books', value:'books-ca'},
	{category:'Music', value:'music-ca'},
	{category:'Classical Music', value:'classical-ca'},
	{category:'Video VHS', value:'vhs-ca'},
	{category:'DVD', value:'dvd-ca'},
	{category:'Software', value:'software-ca'},
	{category:'Computer & Video Games', value:'video-games-ca'},
	{category:'Livres en Fran\xE7ais', value:'books-ca-fr'}
];


var localCategories_jp = [
	{category:'すべての商品', value:'blended'},
	{category:'和書', value:'books-jp'},
	{category:'洋書', value:'books-us'},
	{category:'エレクトロニクス', value:'electronics-jp'},
	{category:'コンピュータ', value:'electronics-jp&field-browse=3371341'},
	{category:'ホーム&キッチン', value:'kitchen-jp'},
	{category:'ポピュラー音楽', value:'music-jp'},
	{category:'クラシック', value:'classical-jp'},
	{category:'DVD', value:'dvd-jp'},
	{category:'ビデオ', value:'vhs-jp'},
	{category:'ソフトウェア', value:'software-jp'},
	{category:'ゲーム', value:'videogames-jp'},
	{category:'おもちゃ\x26ホビー', value:'toys-jp'}
];



function setup() {
	
    if (window.widget) {
    	
		if ( widget.preferenceForKey("local") ) { // if preference is set -->
			local = widget.preferenceForKey("local"); // set local var to preference
		} else {
			//widget.system("/usr/bin/osascript -e 'say \"Welcome to Amazon Search!\" using \"Victoria\"'" , null);
			//widget.setPreferenceForKey(local,"local");
		}
		
		//////////////////////////////////////////////////
		
		categoryIndex = widget.preferenceForKey("cat");
		
		if (!categoryIndex) {
			categoryIndex=0;
			widget.setPreferenceForKey(categoryIndex,"cat");
		}
		
		checkVersion();
		
		stretcher = new Stretcher(document.getElementById('front'), 30, 400, changeText);
		setLocal();
		
	}
}

function setLocal() {
	
	//selected = document.getElementById('selectLocal');
	//local = document.getElementById('selectLocal').value;
	switch (local) {
		case 'de':
			var selectedIndex = 4; break;
		case 'co.uk':
			var selectedIndex = 1; break;
		case 'ca':
			var selectedIndex = 2; break;
		case 'fr':
			var selectedIndex = 3; break;
		case 'co.jp': 	
			var selectedIndex = 5; break;
		default:
			var selectedIndex = 0;
	}
	
	widget.setPreferenceForKey(local,"local");
	
	setPlaceholder();
	setImage();
	createSelectMenu();
	
	
	createLocalMenu();
	// set local menu to preference
	document.getElementById("selectLocal").selectedIndex = selectedIndex;
	
	
}

// switch direction of arrow depending on stretcherPositionOpen before fade in
function mouseSwitch(event) {
	
	if ( stretcherPositionOpen ) {
		document.getElementById("arrow").style.backgroundImage = "url('images/arrow_up.png')";
	} else {
		document.getElementById("arrow").style.backgroundImage = "url('images/arrow_down.png')";
	}
	
	mousemoveArrow(event);
	
}

// Callback for when the stretcher finishes a stretch/shrink
// Based on the state of the widget, display the right status text
function changeText() {
	
	if ( stretcherPositionOpen ) {
		mouseexitArrow(event);
		stretcherPositionOpen = false;
	} else {
		mouseexitArrow(event);
		stretcherPositionOpen = true;
	}
}



function changeLocal(selected) {
	
	//var local = selected.value;
	local = selected.value;
	categoryIndex = 0; // reset category index
	widget.setPreferenceForKey(categoryIndex,"cat");
	
	widget.setPreferenceForKey(local,"local");
	
	setLocal();
	
}


// set the search placeholder text to local language
function setPlaceholder() {
	
	// translate placeholder keyword text
	switch (local) {
		case "de":
			var placeholderText = "Schl\xFCsselwort"; break; // schlüsselwort | Schlüsselwörter | S\xFCchbegriffe
		case "fr":
			var placeholderText = "mot-cl\xE9"; break; // mots-clé | mots-clés | mots de recherche 
		case "co.jp":
			var placeholderText = "キーワード"; break; // キーワード
		default:
			var placeholderText = "keyword";
	}
	
	
	document.getElementById('keyword').setAttribute('placeholder', placeholderText);
}


// set the Amazon logo to the local logo
function setImage() {
	
	switch (local) {
		case "ca":
			var logoImage = "images/AmazonLogo_ca.png"; break;
		case "co.uk":
			var logoImage = "images/AmazonLogo_co.uk.png"; break;
		case "co.jp":
			var logoImage = "images/AmazonLogo_co.jp.png"; break;
		case "de":
			var logoImage = "images/AmazonLogo_de.png"; break;
		case "fr":
			var logoImage = "images/AmazonLogo_fr.png"; break;
		default:
			var logoImage = "images/AmazonLogo_com.png";
	}
	document.getElementById("logo").src = logoImage;
}





function createSelectMenu() {
	
	switch (local) {
		case 'de': 	
			var categories = localCategories_de; break;
		case 'co.uk':
			var categories = localCategories_uk; break;
		case 'co.jp':
			var categories = localCategories_jp; break;
		case 'ca':
			var categories = localCategories_ca; break;
		case 'fr':
			var categories = localCategories_fr; break;
		default:
			var categories = localCategories_com;
	}

	var select = document.getElementById('categoryMenu');

	while (select.hasChildNodes())
		select.removeChild(select.firstChild);

	for (var j = 0; j < categories.length; j++) {
		
		var element = document.createElement("option");
		
		element.innerText = categories[j].category;
		element.setAttribute("name",categories[j].category);
		element.setAttribute("value",categories[j].value);
		select.appendChild(element);
	}
    
    select.options[categoryIndex].selected = true;
    productText.innerText = categories[categoryIndex].category;
	

}

function createLocalMenu() {
	
	var localRegions = [
		{local:'United States', value:'com'},
		{local:'United Kingdom', value:'co.uk'},
		{local:'Canada', value:'ca'},
		{local:'France', value:'fr'},
		{local:'Germany', value:'de'},
		{local:'Japan', value:'co.jp'}
	];

	var select = document.getElementById('selectLocal');

	while (select.hasChildNodes())
		select.removeChild(select.firstChild);

	for (var j = 0; j < localRegions.length; j++) {
		
		var element = document.createElement("option");
		
		//element.innerText = localRegions[j].local;
		element.innerText = getLocalizedString(localRegions[j].local);
		//element.setAttribute("name",localRegions[j].local);
		element.setAttribute("value",localRegions[j].value);
		select.appendChild(element);
	}
    
    //select.options[categoryIndex].selected = true;
    //productText.innerText = localRegions[categoryIndex].category;
	

}


function changeCategory(select) {
	
	switch (local) {
		case 'de':
			var categories = localCategories_de; break;
		case 'co.uk':
			var categories = localCategories_uk; break;
		case 'co.jp':
			var categories = localCategories_jp; break;
		case 'ca':
			var categories = localCategories_ca; break;
		case 'fr':
			var categories = localCategories_fr; break;
		default:
			var categories = localCategories_com;
	}
	
	productText.innerText = categories[select.selectedIndex].category;
	
	categoryIndex = select.selectedIndex;
	widget.setPreferenceForKey(categoryIndex,"cat");
}



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function submitField(keyword) {
	
	if (window.widget) {
		
		switch (local) {
			case 'de':
				var associateId = 'kontrastlab03-21'; break;
			case 'co.uk':
				var associateId = 'kontrastlabs-21'; break;
			case 'co.jp':
				var associateId = 'kontrastlabs-22'; break;
			case 'ca':
				var associateId = 'kontrastlab02-20'; break;
			case 'fr':
				var associateId = 'kontrastlab0c-21'; break; //kontrastlab0b-21
			default:
				var associateId = 'kontrastlabs-20';
		}
		
		if ( keyword.value.length > 1 ) {
			searchKeywords = keyword.value.replace(/[\s]/gi, '+');
			
			//amazonURL = "http://www.amazon." + local + "/exec/obidos/redirect-home/" + associateId;
			amazonURL = "http://www.amazon." + local + "/exec/obidos/external-search?tag=" + associateId + "&keyword=" + searchKeywords;
			if ( stretcherPositionOpen ) {
				amazonURL += "&index=" + document.getElementById('categoryMenu').options[categoryIndex].value;
			} else {
				amazonURL += "&index=blended";
			}
			
			widget.openURL(amazonURL);
		}
		
		
	}
}


////////////////////////////////////////////////////////////////////////////////

// mouseover events for WishCentral
function enterWishCentral(event) {
    document.getElementById('preference_text_over').style.visibility = "visible";
}

function exitWishCentral(event) {
    document.getElementById('preference_text_over').style.visibility = "hidden";
}

function wrapURL(url) {
    if (window.widget)
        widget.openURL(url);
    else
        window.location = url;
}
