
// circle over i on event
function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}


function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	window.resizeBy(0,90);
	//window.resizeTo(210,100);
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
				
	front.style.display="none";
	back.style.display="block";
	
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}


function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	back.style.display="none";
	front.style.display="block";
	
	
	exitflip(event);
	
	window.resizeBy(0,-90);
	//window.resizeTo(210,190);
	
	document.getElementById("doneButton").src = "images/button_done.png";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}


////////////////////////////////////////////////////////////////////////////////

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
    if (!flipShown) {
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit(event) {
    if (flipShown) {
        // fade in the info button
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate() {
    var T;
    var ease;
    var time = (new Date).getTime();
                
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration) {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

var arrowShown = false;
var arrowAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemoveArrow(event) {
    if (!arrowShown) {
        if (arrowAnimation.timer != null) {
            clearInterval (arrowAnimation.timer);
            arrowAnimation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        arrowAnimation.duration = 1000;
        arrowAnimation.starttime = starttime;
        arrowAnimation.firstElement = document.getElementById ('arrow');
        arrowAnimation.timer = setInterval ("animateArrow();", 13);
        arrowAnimation.from = arrowAnimation.now;
        arrowAnimation.to = 0.8;
        animateArrow();
        arrowShown = true;
    }
}

function mouseexitArrow(event) {
    if (arrowShown) {
        // fade in the info button
        if (arrowAnimation.timer != null) {
            clearInterval (arrowAnimation.timer);
            arrowAnimation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        arrowAnimation.duration = 500;
        arrowAnimation.starttime = starttime;
        arrowAnimation.firstElement = document.getElementById ('arrow');
        arrowAnimation.timer = setInterval ("animateArrow();", 13);
        arrowAnimation.from = arrowAnimation.now;
        arrowAnimation.to = 0.0;
        animateArrow();
        arrowShown = false;
    }
}
function animateArrow() {
    var T;
    var ease;
    var time = (new Date).getTime();
                
    T = limit_3(time-arrowAnimation.starttime, 0, arrowAnimation.duration);
        
    if (T >= arrowAnimation.duration) {
        clearInterval (arrowAnimation.timer);
        arrowAnimation.timer = null;
        arrowAnimation.now = arrowAnimation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / arrowAnimation.duration));
        arrowAnimation.now = computeNextFloat (arrowAnimation.from, arrowAnimation.to, ease);
    }
        
    arrowAnimation.firstElement.style.opacity = arrowAnimation.now;
}

//////////////////////////////////////////////////////////


function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}


// http://developer.apple.com/documentation/AppleApplications/Conceptual/Dashboard_Tutorial/index.html
//////////////////////////////////////////////////////////

function getLocalizedString(key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}
